"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.init = init;
exports.openBrowser = openBrowser;
exports.closeBrowser = closeBrowser;
exports.ID = void 0;

var _adb = _interopRequireDefault(require("./adb"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

let adb;
let taikoSession;
let page;
let tcpProp;
process.env['LOCAL_PROTOCOL'] = true;

let _openBrowser;

let _closeBrowser;

let _eventEmitter;

const ID = 'android';
exports.ID = ID;

function init(taiko, eventEmitter) {
  _eventEmitter = eventEmitter;
  _openBrowser = taiko.openBrowser;
  _closeBrowser = taiko.closeBrowser;

  _eventEmitter.addListener('createdSession', async () => {
    taikoSession = await taiko.client();
    page = taikoSession.Page;
    Promise.all([page.enable()]);
  });
}

async function openBrowser() {
  adb = new _adb.default();
  await adb.checkIfDevices();
  let tcpDetails = await adb.portForwardTcp();
  tcpProp = Object.assign({}, ...tcpDetails.map(tcp => ({
    tcp
  })));
  const device = tcpProp.tcp.device;
  await adb.closeChrome(device);
  await adb.skipChromeWelcomeScreen(device);
  await adb.openChrome(device);
  await adb.currentActivity(device);
  await _openBrowser(tcpProp.tcp);
  return {
    description: 'Browser opened'
  };
}

async function closeBrowser() {
  await _closeBrowser();
  await adb.closeChrome(tcpProp.tcp.device);
}